﻿using System.Data;
using System.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;

namespace MyWpfTestSolution
{
    public partial class MainWindow : Window
    {
        private static string l1 = "Level1";
        private static string l2 = "Level2";
        private static string someInfo = "Some info";

        public MainWindow()
        {
            InitializeComponent();

            dGrid.InitializeRecord +=
                (object sender, InitializeRecordEventArgs e) =>
                {
                    if (e.Record is GroupByRecord)
                    {
                        e.Record.IsExpanded = true;
                    }
                };

            DataTable table = new DataTable();
            table.Columns.Add(l1, typeof(int));
            table.Columns.Add(l2, typeof(int));
            table.Columns.Add(someInfo, typeof(MyClass));

            for (int level1 = 0; level1 < 1; level1++)
            {
                for (int level2 = 0; level2 < 1; level2++)
                {
                    DataRow row = table.Rows.Add();
                    row[l1] = level1;
                    row[l2] = level2;
                    row[someInfo] = new MyClass();
                }
            }
            dGrid.DataSource = table.DefaultView;
            table.AcceptChanges();
        }
    }

    internal class MyClass
    {
        private static string l3 = "Level3";
        private static string someInfo = "Some info";
        public DataTable SomeUsefullData { get; set; }

        public MyClass()
        {
            SomeUsefullData = new DataTable();
            SomeUsefullData.Columns.Add(l3);
            SomeUsefullData.Columns.Add(someInfo, typeof(int));
            for (int level3 = 0; level3 < 3; level3++)
            {
                for (int j = 0; j < 10; j++)
                {
                    var dataRow = SomeUsefullData.Rows.Add();
                    dataRow[l3] = level3;
                    dataRow[someInfo] = j;
                }
            }
            SomeUsefullData.AcceptChanges();
        }
    }
}
